#!/bin/sh

############################################################################
## Duel script v1.0 by SUbzEro                                            ##
## ---------------------------                                            ##
## This script was made on request by nevoc`                              ##
## How-to install this:                                                   ##
## chmod -R 777 <glftpd-dir>/ftp-data/users                               ##
## chmod -R 777 <glftpd-dir>/ftp-data/msgs                                ##
## touch <glftpd-dir>/bin/tmpduelfile                                     ##
## chmod 777 <glftpd-dir>/bin/tmpduelfile                                 ##
## And here are the sitebot lines:                                        ##
## set variables(DUELREQ)     "%requester %user %credits"                 ##
## set variables(DUEL)        "%requester %user %credits %firstshooter"   ##
## set variables(DUELSHOT)    "%shooter %result %shots"                   ##
## set variables(DUELEND)     "%shooter %shots %credits"                  ##
## set variables(DUELEND2)    "%blah"                                     ##
## I guess you know how to add them correctly!                            ##
############################################################################

GLDIR="/glftpd"
GLUSERDIR="/ftp-data/users" # Set this to your userdir.
GLLOGFILE="/ftp-data/logs/glftpd.log" # Set this to your glftpd.log.
GLMSGDIR="/ftp-data/msgs" # Set this to your message dir.
DUELS="/ftp-data/logs/duels" # Dont edit this.
CREDITS="500" # Here you set the credits that a user would gain/loose.
SLEEP="15" # Seconds between each shot, dont use below 1!
MAXSHOTS="7" # Set this to the max shots (minus one) for ALL users.
MAXHOURS="2" # Number of hours a duel request can stay.
VER="1.0" #Dont edit this.



#### !!!! - DONT EDIT BELOW THIS LINE - !!!! ####

if [ "$2" = "clean" ]; then

 TIME=`date --date '+'$MAXHOURS' hours ago' "+%H:%M:%S %d-%m-%Y"`
 cat $GLDIR/bin/tmpduelfile | grep -v "$TIME" > $GLDIR/$DUELS

else

## Help cmd
 if [ "$1" = "" ]; then
  echo "-- SUbzEro's duel script $VER --"
  echo "You will battle about $CREDITS MB, but if you dont have this amount, you can specify you own amount!"
  echo "Usage:"
  echo "site duel <login> - Use this to duel another user."
  echo "site duel <login> <MB> - Use this to duel another user with <MB> as amount."
  echo "site duel <login> accept - Use this to accept another users duel request."
  echo "-- Enjoy! --"
 fi
###########

 if [ "$1" != "" ]; then
  echo "-- SUbzEro's duel script $VER --"

## Checking for the target user
  if [ ! -e $GLUSERDIR/$1 ]; then
   echo "The user $1 does not exist!"
   exit 0
  fi

  if [ "$1" = "$USER" ]; then
   echo "You cant battle yourself!"
   exit 0
  fi

  if [ ! "$2" = "" ]; then
   if [ ! "$2" = "accept" ]; then
    CREDITS=$2
    OWN="1"
    echo "Playing for $CREDITS MB"
   fi
  fi

  OWNRATIO=`cat $GLUSERDIR/$USER | grep RATIO | grep 0`
  TARGETRATIO=`cat $GLUSERDIR/$1 | grep RATIO | grep 0`

  if [ "$OWNRATIO" != "" ]; then
   echo "You cant play this game when you have leech!"
   exit 0
  fi

  if [ "$TARGETRATIO" != "" ]; then
   echo "$1 got leech, therefore you cant challenge him!"
   exit 0
  fi

  CREDS=`cat $GLUSERDIR/$USER | grep CREDITS | awk -F" " '{print $2}'`
  CRED=`expr $CREDS \/ 1000`
  if [ ! "$CRED" -gt "$CREDITS" ]; then
   echo "You do not have enough creds. Breaking off."
   exit 0
  fi

  CREDS=`cat $GLUSERDIR/$1 | grep CREDITS | awk -F" " '{print $2}'`
  CRED=`expr $CREDS \/ 1000`
  if [ ! "$CRED" -gt "$CREDITS" ]; then
   echo "$1 do not have enough creds. Breaking off."
   exit 0
  fi

###############################

## Duel Request
 if [ "$2" = "" ] || [ "$OWN" = "1" ]; then
  touch $GLMSGDIR/$1
  echo "
!HFrom: !CSUbzEro's Duel script $VER !H(!C`date "+%a %b %d %T %Y"`!H)!0
Hey $1!
$USER sent you a duel request, for the battle of $CREDITS MB!
Use 'site duel $USER accept' to take up his request and fight him!
Enjoy!
" >> $GLMSGDIR/$1
  TIME=`date "+%H:%M:%S %d-%m-%Y"`
  echo "Requested Duel: $USER $1 $CREDITS $TIME" >> $DUELS
  echo `date +"%a %b %d %T %Y"` DUELREQ: \"/site/dox/duel\" \"$USER\" \"$1\" \"$CREDITS\" >> $GLLOGFILE
  echo "Duel request sent to $1"
 fi
###############

## Accepting Duel Request
 if [ "$2" = "accept" ]; then

  if [ ! -e /tmp/subtemp.txt ]; then
   echo "game in progress" > /tmp/subtemp.txt
  else
   echo "someone else is playing atm. Try again later"
   exit 0
  fi

 CHECK=`grep "Requested Duel: $1 $USER" $DUELS`
 if [ "$CHECK" != "" ]; then 
  CREDITS="`echo "$CHECK" | { read ignore1 ignore2 ignore3 ignore4 CREDITS ignore5; echo $CREDITS; }`"
# CHECK=`grep "Requested Duel: $1 $USER $CREDITS" $DUELS`
  echo "
!HFrom: !CSUbzEro's Duel script $VER !H(!C`date "+%a %b %d %T %Y"`!H)!0
Hey $1!
$USER accepted your duel request!
Battle will start now.
Enjoy!
" >> $GLMSGDIR/$1

  cat $DUELS | grep -v "Requested Duel: $1 $USER $CREDITS" > $DUELS

  randnum=$RANDOM
  let "randnum %= 2"
  if [ "$randnum" = "0" ]; then
   SHOOTER="$USER"
  else
   SHOOTER="$1"
  fi

  echo `date +"%a %b %d %T %Y"` DUEL: \"/site/dox/duel\" \"$1\" \"$USER\" \"$CREDITS\" \"$SHOOTER\" >> $GLLOGFILE
  echo "Accepted duel request from $1"

  echo " 
$1 0   
$USER 0
" >> /bin/tmpduelfile
  cat /bin/tmpduelfile | grep -v "$SHOOTER" > /bin/tmpduelfile
  echo "$SHOOTER 1" >> /bin/tmpduelfile
  SHOTS=`cat /bin/tmpduelfile | grep $SHOOTER | awk -F" " '{print $2}'`

  RESULT=$RANDOM
  let "RESULT %= 15"
  if [ "$RESULT" = "1" ]; then
   RESULT="HITS"
   echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
   /bin/sleep $SLEEP
   echo `date +"%a %b %d %T %Y"` DUELEND: \"/site/dox/duel\" \"$SHOOTER\" \"$SHOTS\" \"$CREDITS\" >> $GLLOGFILE
  elif [ "$RESULT" = "2" ]; then
   RESULT="HITS"
   echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
   /bin/sleep $SLEEP
   echo `date +"%a %b %d %T %Y"` DUELEND: \"/site/dox/duel\" \"$SHOOTER\" \"$SHOTS\" \"$CREDITS\" >> $GLLOGFILE
  else
   RESULT="MISSES"
  fi

  echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
  TOTALSHOTS="1"
  /bin/sleep $SLEEP

  while [ "$RESULT" != "HIT" ]; do

   if [ "$SHOOTER" = "$1" ]; then
    SHOOTER="$USER"
   else
    SHOOTER="$1"
   fi

   if [ "$TOTALSHOTS" -ge "$MAXSHOTS" ]; then
    echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
    /bin/sleep $SLEEP
    echo `date +"%a %b %d %T %Y"` DUELEND2: \"/site/dox/duel\" "Nowinner" >> $GLLOGFILE
    WINNER="NOWINNER"
    break 2
   fi

   SHOTS=`cat /bin/tmpduelfile | grep $SHOOTER | awk -F" " '{print $2}'`

   SHOTS=`expr $SHOTS + 1`
   cat /bin/tmpduelfile | grep -v "$SHOOTER" > /bin/tmpduelfile
   echo "$SHOOTER $SHOTS" >> /bin/tmpduelfile

   RESULT=$RANDOM
   let "RESULT %= 15"
   if [ "$RESULT" = "1" ]; then
    RESULT="HITS"
    echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
    /bin/sleep $SLEEP
    echo `date +"%a %b %d %T %Y"` DUELEND: \"/site/dox/duel\" \"$SHOOTER\" \"$SHOTS\" \"$CREDITS\" >> $GLLOGFILE
    break
   elif [ "$RESULT" = "2" ]; then
    RESULT="HITS"
    echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
    /bin/sleep $SLEEP
    echo `date +"%a %b %d %T %Y"` DUELEND: \"/site/dox/duel\" \"$SHOOTER\" \"$SHOTS\" \"$CREDITS\" >> $GLLOGFILE
    break
   else
    RESULT="MISSES"
   fi

   echo `date +"%a %b %d %T %Y"` DUELSHOT: \"/site/dox/duel\" \"$SHOOTER\" \"$RESULT\" \"$SHOTS\" >> $GLLOGFILE
   /bin/sleep $SLEEP

   TOTALSHOTS=`expr $TOTALSHOTS + 1`

  done

  if [ "$WINNER" != "NOWINNER" ]; then

   if [ "$SHOOTER" = "$1" ]; then
    LOSER="$USER"
   else
    LOSER="$1"
   fi


   OLDCREDITS=`cat $GLUSERDIR/$LOSER | grep CREDITS | awk -F" " '{print $2}'`
   let "CREDITSLOST = 1000 * $CREDITS"
   NEWCREDITS=`expr $OLDCREDITS - $CREDITSLOST`
   cat $GLUSERDIR/$LOSER | grep -v "CREDITS $OLDCREDITS" > $GLUSERDIR/$LOSER
   echo "CREDITS $NEWCREDITS" >> $GLUSERDIR/$LOSER

   OLDCREDITS=`cat $GLUSERDIR/$SHOOTER | grep CREDITS | awk -F" " '{print $2}'`
   let "CREDITSWON = 1000 * $CREDITS"
   NEWCREDITS=`expr $OLDCREDITS + $CREDITSWON`
   cat $GLUSERDIR/$SHOOTER | grep -v "CREDITS $OLDCREDITS" > $GLUSERDIR/$SHOOTER
   echo "CREDITS $NEWCREDITS" >> $GLUSERDIR/$SHOOTER

   if [ -e /tmp/subtemp.txt ]; then
    rm -f /tmp/subtemp.txt
   else
    donothing=1
   fi
  else
   if [ -e /tmp/subtemp.txt ]; then
    rm -f /tmp/subtemp.txt
   else
    donothing=1
   fi
  fi

  cat /bin/tmpduelfile | grep -v "$1" > /bin/tmpduelfile
  cat /bin/tmpduelfile | grep -v "$USER" > /bin/tmpduelfile

 else
#  if [ -e /tmp/subtemp.txt ]; then
#   rm -f /tmp/subtemp.txt
#  else
#   donothing=1
#  fi
  echo "$1 didnt request a duel with you!"
 fi

fi
#########################

 echo "-- Enjoy! --"
 fi

fi
